(in-package :cleric)

(define-condition not-implemented-error (program-error)
  ((comment :reader comment :initarg :comment)))

(define-condition try-again ()
  ((reason :reader reason :initarg :reason)))

(define-condition handshake-failed-error (error)
  ((reason :reader reason :initarg :reason)))

(define-condition connection-closed-error (error)
  ;; END-OF-FILE
  ())

(define-condition node-unreachable-error (error)
  ;; USOCKET:CONNECTION-REFUSED-ERROR
  ())

(define-condition epmd-host-unknown-error (error)
  ;; USOCKET:UNKNOWN-ERROR
  ())

(define-condition epmd-unreachable-error (error)
  ;; USOCKET:CONNECTION-REFUSED-ERROR
  ())


(define-condition epmd-response-error (error)
  ;; Useful?
  ())

(define-condition malformed-message-error (error)
  ((bytes :reader bytes :initarg :bytes)))

(define-condition malformed-external-erlang-term-error (error)
  ((bytes :reader bytes :initarg :bytes)))

(define-condition untranslatable-lisp-object-error (error)
  ((object :reader object :initarg :object)))

(define-condition unexpected-message-length-error (malformed-message-error)
  ((received-length :reader received-length :initarg :received-length)
   (expected-length :reader expected-length :initarg :expected-length)))

(define-condition unexpected-message-tag-error (malformed-message-error)
  ((received-tag :reader received-tag :initarg :received-tag)
   (expected-tags :reader expected-tags :initarg :expected-tags)))
